# Lookup & Item Extractor

Use this utility to extract both `lookup` and `item` and its dependencies.

## Usage

Run the command below:

```
mpack extract --username=YOUR_USERNAME --password=YOUR_PASSWORD --url=DOMAIN_URL --id=LOOKUP_ID --folder=FOLDER_ID --withJson --type=TYPE
```

### Options
| Options | Required? | Description | Example |
|---|---|---|---|
| `--username` | `no` | Required as part of the credentials to login to the system for extracting `lookup`, you can also set it within config.json | `--username=YOUR_USERNAME` |
| `--password` | `no` | Required as part of the credentials to login to the system for extracting `lookup`, you can also set it within config.json | `--password=YOUR_PASSWORD` |
| `--url` | `no` | Required, specify which domain should be targeted for extracting `lookup`, you can also set it within config.json | `--url=https://meepmeep.dev.datumcorp.com` |
| `--id` | `yes` | Identify which `lookup` or `item` is to be extracted, use `,` for extracting multiple `lookups` or `items`, or both together. If provided `*`, `--type` is required. | `--id=lLIyaGhKT5GqcWKQAzpjSw` or `--id=O4fhKIFyTyy_Ak3InvTUEA,wL7fMdI7QVesX6Oo1Zy3JQ` or `--id=*` |
| `--folder` | `no` | Optional for `lookup` but required for `item`. For `lookup`, for providing target folderId for extracting `folder settings` and `SchedulePrefs` | `--folder=AAAAAwAAQACAAAAAAAAAAQ` |
| `--withJson` | `no` | Optional. If provided, the extractor will also output results in JSON file alongside YAML file. | `--withJson` |
| `--type` | `yes` If `--id=*` | If `--id=*` provided, this will be used to indicate what item are to be extracted. For `Items`, use `item`. For lookup, use `type` number. | `--type=item,8,9,13` |

### Output
Upon extracted successfully, an `out` folder will be created with the following structure:

- Extracted `lookup` will reside within the folder of their own `type`, usually an `integer`, with their `name (id)` as filename.
- Extracted `non-lookup with appcode` will reside within the folder of their own `appcode`, usually a `string`, filename is in `APP__id` format. Eg. Extracted `schedPrefs` will stay inside `"SCH"` folder, named as `"SCH__UUID.yaml"`.
- Extracted `folder settings` will reside within the folder named `settings`, with file named by their `key`.

## Supported Lookup Dependencies Extraction
Below listed all the supported `lookup.type` where their dependencies can be extracted by extractor:

| Type | Extractable Dependencies |
|---|---|
| `L9` | `L13` |
| `L8` | `SCH` |
| `L13` | `L9`, `Folder Settings*` |
| `L90` | `L9`, `SCH*`, `L40`, `Folder Settings*` |
| `L40` | `L9` |

\* `--folder` required

## Bugs
The following are the bugs found while using this utilities, stay cautions.

```yaml
- It is possible that if exporting any lookups that have dependencies, output may miss out a few. (FIXED 12/11/19)
```

## Backlogs
* Sanitize Checking